<!--
 * @Descripttion: 当前组件信息
 * @version: 1.0.0
 * @Author: 无尘
 * @Date: 2018-10-10 14:44:45
 * @LastEditors: 无尘
 * @LastEditTime: 2020-12-07 16:38:07
 -->
<template>
  <div class="unreview-wrap common-set-wrap">
    <div class="right-content">
      <div class="right-box" style="min-height: calc(100vh - 126px)">
        <div class="m-b-20">
          <nav-crumb :navpath="navpath"> </nav-crumb>
        </div>
        <div class="text-right m-b-20"><el-button @click="handleAdd('')" type="primary">新增企业关系</el-button></div>
        <div class="reviewed-body-content">
          <el-table ref="multipleTable" v-loading="loading" :data="tableData" tooltip-effect="dark" style="width: 100%" @selection-change="handleSelectionChange">
            <el-table-column label="企业名称" show-overflow-tooltip>
              <template slot-scope="scope">
                {{ scope.row.enterpriseName || '--' }}
              </template>
            </el-table-column>
            <el-table-column label="企业ID" show-overflow-tooltip>
              <template slot-scope="scope">
                {{ scope.row.enterpriseId || '--' }}
              </template>
            </el-table-column>
            <el-table-column label="QPS" show-overflow-tooltip>
              <template slot-scope="scope">
                {{ scope.row.count || '--' }}
              </template>
            </el-table-column>
            <el-table-column label="关联类型" show-overflow-tooltip>
              <template slot-scope="scope">
                {{ scope.row.relationType == 0 ? 'GIC' : '自定义' }}
              </template>
            </el-table-column>
            <el-table-column label="操作">
              <template slot-scope="scope">
                <!-- <el-button type="text" @click="toNext(scope.row)">查看详情</el-button> -->
                <el-button @click="handleAdd(scope.row)" type="text">编辑</el-button>
                <el-button @click="handlDel(scope.$index, scope.row)" type="text">删除</el-button>
              </template>
            </el-table-column>
          </el-table>
          <!-- <div class="block common-wrap__page text-right" v-if="tableData.length != 0">
            <dm-pagination background @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="currentPage" :page-sizes="[20, 40, 60, 80]" :page-size="pageSize" layout="total, sizes, prev, pager, next, jumper" :total="total"> </dm-pagination>
          </div> -->
        </div>
      </div>
    </div>
    <!-- 编辑 -->
    <el-dialog :title="!!ruleForm.rateEnterpriseId ? '编辑企业关系' : '新建企业关系'" :visible.sync="showAdd" width="600px" :before-close="handleClose">
      <div class="">
        <el-form :model="ruleForm" :rules="rules" ref="ruleForm" label-width="100px" class="demo-ruleForm">
          <el-form-item v-if="ruleForm.rateEnterpriseId ? false : true" label="关联类型" prop="relationType">
            <el-select class="w-360" v-model="ruleForm.relationType" placeholder="请选择关联类型" @change="changeType">
              <el-option label="GIC" value="0"> </el-option>
              <el-option label="自定义" value="1"> </el-option>
            </el-select>
          </el-form-item>
          <el-form-item v-if="ruleForm.relationType == 1" label="商户 ID" prop="enterpriseId">
            <el-input class="w-360" :disabled="ruleForm.rateEnterpriseId ? true : false" v-model="ruleForm.enterpriseId" placeholder="请输入商户 ID"></el-input>
          </el-form-item>
          <el-form-item v-if="ruleForm.relationType == 1" label="商户名称" prop="enterpriseName">
            <el-input class="w-360" :disabled="ruleForm.rateEnterpriseId ? true : false" v-model="ruleForm.enterpriseName" placeholder="请输入商户名称"></el-input>
          </el-form-item>
          <el-form-item v-if="ruleForm.relationType == 0" label="选择企业" prop="enterpriseDatas">
            <!-- <el-input v-model="ruleForm.name" placeholder="请输入企业关系"></el-input> -->
            <!-- <el-select class="w-360" :disabled="ruleForm.rateEnterpriseId ? true : false" multiple v-model="ruleForm.enterpriseDatas" placeholder="请选择">
              <el-option v-for="item in options" :key="item.enterpriseId" :label="item.enterpriseName" :value="item.enterpriseId"> </el-option>
            </el-select> -->
            <el-select class="w-360" :disabled="ruleForm.rateEnterpriseId ? true : false" v-model="ruleForm.eids" multiple filterable remote reserve-keyword placeholder="请输入企业名称搜索" :remote-method="remoteMethod" :loading="loading">
              <el-option v-for="item in options" :key="item.enterpriseId" :label="item.enterpriseName" :value="item.enterpriseId"> </el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="QPS" prop="count">
            <el-input-number class="w-360" v-model="ruleForm.count" placeholder="请输入" controls-position="right" :min="1" :max="90000000"></el-input-number>
          </el-form-item>
        </el-form>
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button @click="toCancel">取消</el-button>
        <el-button type="primary" @click="submitForm('ruleForm')">确定</el-button>
      </div>
    </el-dialog>
  </div>
</template>
<script>
import navCrumb from '@/components/nav/nav-app.vue';
import showMsg from '@/common/js/showmsg';
import errMsg from '@/common/js/error';
import { _debounce } from '@/common/js/public';
import { getRequest, postRequest } from '@/api/api';
export default {
  name: 'unreview',
  components: { navCrumb },
  data() {
    const validateId = (rule, value, callback) => {
      if (this.ruleForm.relationType == 1 && value === '') {
        callback(new Error('请输入商户 ID'));
      } else {
        callback();
      }
    };
    const validateName = (rule, value, callback) => {
      if (this.ruleForm.relationType == 1 && value === '') {
        callback(new Error('请输入商户名称'));
      } else {
        callback();
      }
    };
    return {
      wxEnterpriseId: localStorage.getItem('userInfos') ? JSON.parse(localStorage.getItem('userInfos')).wxEnterpriseId : '',
      auditName: localStorage.getItem('userInfos') && JSON.parse(localStorage.getItem('userInfos')).staffDTO ? JSON.parse(localStorage.getItem('userInfos')).staffDTO.staffName : '',
      // 面包屑参数
      navpath: [
        {
          name: '模块',
          path: '/index'
        },
        {
          name: '限流',
          path: `/second?moudleId=${this.$route.query.moudleId}`
        },
        {
          name: '企业关系',
          path: ''
        }
      ],

      loading: false,
      tableData: [],
      options: [],

      // 分页参数
      currentPage: 1,
      pageSize: 20,
      total: 0,
      showAdd: false,
      ruleForm: {
        relationType: '0',
        enterpriseId: '',
        enterpriseName: '',
        rateEnterpriseId: '',
        eids: [],
        enterpriseDatas: [],
        count: ''
      },
      rules: {
        enterpriseId: [{ required: true, validator: validateId, message: '请输入商户 ID', trigger: 'blur' }],
        enterpriseName: [{ required: true, validator: validateName, message: '请输入商户名称', trigger: 'blur' }],
        enterpriseDatas: [{ type: 'array', required: true, message: '请选择企业', trigger: 'blur' }],
        count: [{ required: true, message: '请输入', trigger: 'blur' }]
      },
      optionsCopy: []
    };
  },
  methods: {
    changeType(e) {
      const that = this;
      that.$refs['ruleForm'].resetFields();
      that.ruleForm.relationType = e;
      that.ruleForm.enterpriseDatas = [];
      that.ruleForm.eids = [];
      that.ruleForm.enterpriseId = '';
      that.ruleForm.enterpriseName = '';
    },
    remoteMethod(query) {
      const that = this;
      if (query !== '') {
        that.loading = true;
        setTimeout(() => {
          that.loading = false;
          that.options = that.optionsCopy.filter(ele => {
            return ele.enterpriseName.indexOf(query) != -1;
          });
        }, 200);
      } else {
        that.options = JSON.parse(JSON.stringify(that.optionsCopy));
      }
    },
    /**
     * 弹窗操作
     */
    toCancel() {
      const that = this;
      that.closeText();
      that.$refs['ruleForm'].resetFields();
    },
    handleClose(done) {
      const that = this;
      that.closeText();
      that.$refs['ruleForm'].resetFields();
    },
    submitForm: _debounce(function(formName) {
      const that = this;
      if (that.ruleForm.relationType == 1) {
        that.ruleForm.enterpriseDatas = [
          {
            enterpriseId: that.ruleForm.enterpriseId,
            enterpriseName: that.ruleForm.enterpriseName
          }
        ];
      } else {
        that.ruleForm.enterpriseDatas = that.optionsCopy.filter(ele => {
          if (that.ruleForm.eids.indexOf(ele.enterpriseId) != -1) {
            return { enterpriseId: ele.enterpriseId, enterpriseName: ele.enterpriseName };
          }
        });
      }
      that.$refs[formName].validate(valid => {
        if (valid) {
          that.postSave();
        }
      });
    }, 300),
    postSave() {
      const that = this;
      const data = {
        rateId: that.$route.query.rateId,
        relationType: that.ruleForm.relationType,
        rateEnterpriseId: that.ruleForm.rateEnterpriseId,
        enterpriseDatas: !that.ruleForm.rateEnterpriseId ? JSON.stringify(that.ruleForm.enterpriseDatas) : '',
        count: that.ruleForm.count
      };
      postRequest(!that.ruleForm.rateEnterpriseId ? '/redis-limiter-web/redislimiter/save-rate-enterprise' : '/redis-limiter-web/redislimiter/save-rate-enterprise-single', data)
        .then(res => {
          let resData = res.data;
          if (resData.errorCode == 1) {
            showMsg.showmsg('操作成功', 'success');
            that.$refs['ruleForm'].resetFields();
            that.closeText();
          } else {
            errMsg.errorMsg(resData);
          }
        })
        .catch(error => {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },
    /**
     * 新增或编辑
     */
    handleAdd(row) {
      const that = this;
      that.getEntepriseList();
      if (row) {
        row.eids = [row.enterpriseId];
        row.enterpriseDatas = [
          {
            enterpriseId: row.enterpriseId,
            enterpriseName: row.enterpriseName
          }
        ];
        that.ruleForm = JSON.parse(JSON.stringify(row));
      }
      that.showAdd = true;
    },
    closeText() {
      const that = this;
      that.ruleForm = {
        relationType: '0',
        enterpriseId: '',
        enterpriseName: '',
        rateEnterpriseId: '',
        eids: [],
        enterpriseDatas: [],
        count: ''
      };
      that.showAdd = false;
      that.currentPage = 1;
      that.getTableList();
    },
    /**
     * 分页---页码变化
     *  @param {Number} val
     */
    handleSizeChange(val) {
      const that = this;
      that.currentPage = 1;
      that.pageSize = val;
      that.getTableList();
    },

    /**
     * 分页---当前页变化
     *  @param {Number} val
     */
    handleCurrentChange(val) {
      const that = this;
      that.currentPage = val;
      that.getTableList();
    },

    /**
     * 操作
     */
    handlDel(index, item) {
      const that = this;
      that
        .$confirm('确认是否删除?', '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        })
        .then(() => {
          that.postApprove(item);
        })
        .catch(() => {});
    },

    /**
     * 确定同意删除
     */
    postApprove(item) {
      const that = this;
      let para = {
        rateEnterpriseId: item.rateEnterpriseId
      };
      postRequest('/redis-limiter-web/redislimiter/del-rate-enterprise', para)
        .then(res => {
          let resData = res.data;
          if (resData.errorCode == 1) {
            showMsg.showmsg('操作成功', 'success');
            that.currentPage = 1;
            that.getTableList();
            return;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },
    /**
     * 获取列表数据
     */
    getTableList() {
      const that = this;
      that.loading = true;
      let para = {
        rateId: that.$route.query.rateId,
        pageNum: that.currentPage, // 当前页
        pageSize: that.pageSize // 一页显示个数
      };
      getRequest('/redis-limiter-web/redislimiter/list-rate-enterprise', para)
        .then(res => {
          let resData = res.data;
          that.loading = false;
          if (resData.errorCode == 1) {
            that.tableData = resData.result || [];
            // that.total = resData.result.totalCount;
            return;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.loading = false;
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },
    /**
     * 获取列表数据
     */
    getEntepriseList() {
      const that = this;
      let para = {};
      getRequest('/redis-limiter-web/redislimiter/list-enterprise', para)
        .then(res => {
          let resData = res.data;
          that.loading = false;
          if (resData.errorCode == 1) {
            that.options = resData.result || [];
            that.optionsCopy = JSON.parse(JSON.stringify(resData.result || []));
            return;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    }
  },
  mounted() {
    const that = this;
    that.$emit('showTab', 1);
    // that.wxEnterpriseId = await that.toLogin();
    that.getTableList();
  }
};
</script>
<style lang="scss" scoped>
.w-250 {
  width: 250px;
}
/* flex */

.flex {
  display: -webkit-box;
  display: -webkit-flex;
  display: -ms-flexbox;
  display: flex;
}

.flex-1 {
  -webkit-box-flex: 1;
  -webkit-flex: 1;
  -ms-flex: 1;
  flex: 1;
}

.flex-column {
  -webkit-flex-direction: column;
  -moz-flex-direction: column;
  -ms-flex-direction: column;
  -o-flex-direction: column;
  flex-direction: column;
}

.flex-row {
  -webkit-flex-direction: row;
  -moz-flex-direction: row;
  -ms-flex-direction: row;
  -o-flex-direction: row;
  flex-direction: row;
}

.flex-align-center {
  -webkit-box-align: center;
  -webkit-align-items: center;
  -ms-flex-align: center;
  align-items: center;
}

.flex-pack-center {
  -webkit-box-pack: center;
  -webkit-justify-content: center;
  -ms-flex-pack: center;
  justify-content: center;
}

.flex-wrap {
  -webkit-flex-wrap: wrap;
  -moz-flex-wrap: wrap;
  -ms-flex-wrap: wrap;
  -o-flex-wrap: wrap;
  flex-wrap: wrap;
}

.flex-space-between {
  -webkit-justify-content: space-between;
  -moz-justify-content: space-between;
  -ms-justify-content: space-between;
  -o-justify-content: space-between;
  justify-content: space-between;
}

.flex-start {
  -webkit-justify-content: flex-start;
  -moz-justify-content: flex-start;
  -ms-justify-content: flex-start;
  -o-justify-content: flex-start;
  justify-content: flex-start;
}

.bg-82C5FF {
  background: #82c5ff;
}

.color-508CEE {
  color: #508cee;
}

.color-FF585C {
  color: #ff585c;
}

.font-13 {
  font-size: 13px;
}

.font-14 {
  font-size: 14px;
}

.line-h-18 {
  line-height: 18px;
}

.line-hidden-2 {
  display: flex;
  align-items: center;
  justify-content: flex-start;
  height: 46px;
  overflow: hidden;
  span {
    display: -webkit-box;
    -webkit-line-clamp: 2;
    line-clamp: 2;
    -webkit-box-orient: vertical;
    box-orient: vertical;
    max-height: 46px;
    overflow: hidden;
  }
}

.w-80 {
  width: 80px;
}

.w-130 {
  display: inline-block;
  width: 130px;
  white-space: nowrap;
  text-overflow: ellipsis;
  overflow: hidden;
}

.w-360 {
  width: 360px;
}

.w-168 {
  display: inline-block;
  width: 168px;
  white-space: nowrap;
  text-overflow: ellipsis;
  overflow: hidden;
}

.common-wrap__page {
  margin-top: 24px;
}

.text-center {
  text-align: center;
}

.text-right {
  text-align: right;
}

.right-content {
  min-height: calc(100% - 126px);
  .right-box {
    background: #fff;
    min-height: 500px;
    padding: 20px;
    .w-280 {
      width: 280px;
    }
    .w-514 {
      width: 514px;
    }
    .m-l-20 {
      margin-left: 20px;
    }
    .m-t-45 {
      margin-top: 45px;
    }
    .v-align-b {
      vertical-align: bottom;
    }
    .reviewed-body-head {
      margin-bottom: 22px;
    }
    .table-head-pic {
      width: 35px;
      height: 35px;
      border-radius: 4px;
      i {
        font-size: 20px;
        color: #e5f3ff;
      }
      img {
        width: 35px;
        height: 35px;
        border-radius: 3px;
      }
    }
    .apply-info {
      margin-left: 15px;
      line-height: 18px;
      span {
        font-size: 14px;
        color: #606266;
        &.font-13 {
          font-size: 13px;
        }
      }
    }
  }
}

.apply-info-detail {
  /*padding: 18px;*/
  -webkit-box-sizing: border-box;
  -moz-box-sizing: border-box;
  box-sizing: border-box;
  .apply-info-img {
    width: 64px;
    height: 64px;
    border-radius: 12px;
    text-align: center;
    i {
      font-size: 106px;
      color: #e5f3ff;
    }
    img {
      width: 64px;
      height: 64px;
      border-radius: 12px;
    }
  }
  .apply-info-name {
    font-size: 16px;
    color: #606266;
  }
  .apply-info-right {
    width: 229px;
    padding-left: 16px;
    font-size: 13px;
    color: #606266;
    -webkit-box-sizing: border-box;
    -moz-box-sizing: border-box;
    box-sizing: border-box;
    .w-80 {
      display: inline-block;
      vertical-align: top;
      color: #606266;
    }
    .w-130 {
      color: #606266;
    }
  }
}

.approve-dialog {
  .el-icon-success {
    display: inline-block;
    vertical-align: middle;
    font-size: 24px;
    color: #67c23a;
  }
  .approve-icon-tip {
    display: inline-block;
    vertical-align: middle;
    margin-left: 6px;
    font-size: 18px;
    color: #303133;
  }
  .approve-tip {
    margin-top: 31px;
    font-size: 14px;
    color: #606266;
  }
  >>> .el-dialog__body {
    padding-top: 0;
  }
  >>> .el-dialog__footer {
    border: none;
    padding: 18px 20px 22px 20px;
  }
}

.refuse-dialog {
  .refuse-tip {
    margin-bottom: 20px;
    font-size: 14px;
    color: #606266;
  }
  >>> .el-dialog__footer {
    border: none;
    /*padding: 18px 20px 22px 20px;*/
  }
  .el-textarea {
    >>> .el-textarea__inner {
      font-size: 14px;
      color: #606266;
      background-color: rgba(255, 255, 255, 0.1);
      resize: none;
    }
  }
}
</style>
